import gtk
from gtk import TRUE, FALSE
import kudzu
import string
import gettext
import gobject

_=gettext.gettext

xml = None
hardware = None


def on_generic_device_select_row (selection):
    (model, iter) = selection.get_selected()
    if iter == None:
        return
    device = model.get_value (iter, 1)
    if device == None:
        return
    if string.find (device.kudzu_device.desc, "|") != -1:
        mfg, desc = string.split (device.kudzu_device.desc, "|")
    elif (device.kudzu_device.deviceclass == kudzu.CLASS_CDROM or
          device.kudzu_device.deviceclass == kudzu.CLASS_HD):
        if string.find(device.kudzu_device.desc, " ") != -1:
            mfg, desc = string.split(device.kudzu_device.desc, " ", 1)
    else:
        mfg = _("Unknown")
        desc = device.kudzu_device.desc

    xml.get_widget ('generic_manufacture_label').set_text (mfg)
    if (device.kudzu_device.driver == "ignore"):
        driver = "none or built-in"
    else:
        driver = device.kudzu_device.driver
    xml.get_widget ('generic_driver_label').set_text (driver)
    if device.kudzu_device.device != None:
        xml.get_widget ('generic_device_label').set_text ('/dev/' + device.kudzu_device.device)
    else:
        xml.get_widget ('generic_device_label').set_text (_("N/A"))

def hydrate (devices):
    tree_view = xml.get_widget ('generic_device_treeview')
    list = tree_view.get_model ()
    list.clear ()
    for device in devices:
        iter = list.append ()
        list.set (iter, 0, device.get_name(), 1, device)
    tree_view.get_selection().select_path ((0,))

def initialize (global_xml, global_hardware):
    global xml, hardware
    xml = global_xml

    hardware = global_hardware
    tree_view = xml.get_widget ('generic_device_treeview')
    tree_view.get_selection ().set_mode (gtk.SELECTION_BROWSE)
    tree_view.get_selection ().connect ("changed", on_generic_device_select_row)
    model = gtk.ListStore (gobject.TYPE_STRING, gobject.TYPE_PYOBJECT)
    model.set_sort_column_id (0, gtk.SORT_ASCENDING)
    tree_view.set_model (model)
    column = gtk.TreeViewColumn ()
    renderer = gtk.CellRendererText ()
    column.pack_start (renderer, TRUE)
    column.add_attribute (renderer, "text", 0)
    tree_view.append_column (column)
    
